/*************************************************************************
*
*************************************************************************/

char	*Sc55dispFuncTbl[6] =
{
	"exSC55_msgSet"      , 
	"exSC55_dotSet"      , 
	"SC55_initDotBuffer" , 
	"SC55_setDotBuffer"  , 
	"exSC55_dotBuffer"   , 
	NULL
};

int					Sc55dotBufXs;
int					Sc55dotBufYs;
unsigned char	   *Sc55dotBuffer;

int					Sc55dotBufC;
int					Sc55dotBufX;
int					Sc55dotBufY;


int		SC55disp_macroInit( char *sqr )
{
	int			i;

	Sc55dotBufXs  = 0;
	Sc55dotBufYs  = 0;
	Sc55dotBuffer = NULL;
	for ( i = 0; Sc55dispFuncTbl[i] != NULL; ++i )
		MMac_extDefine( sqr, Sc55dispFuncTbl[i], Sc55dispFuncTbl[i], MMAC_ATT_EXT, NULL );
	MMac_extDefine( sqr, "_SC55DISP_MACRO_DEFINED", "", MMAC_ATT_NORMAL , NULL );

	return (0);
}

int		_isSC55dot(int ch)
{
	ch &= 0xFF;
	if ( ch == '0' || ch == ' ' )
		return (0);
	else
		return (1);
}

/*************************************************************************
*	SC-55 tfBXvCɕ\
*-------------------------------------------------------------------------
*	$exSC55_msgSet("bZ[W")
*************************************************************************/

int		exSC55_msgSet( char *sqr, size_t bufSiz, char *buf, int argc, char **argv )
{
	int			len, siz;
	char	   *msg;

	if ( argc < 1 )
		goto _ERR;
	msg = argv[0];
	len = strlen(msg);
	if ( len < 1 || len > 32 )
		goto _ERR;
	return sc55_genMML( sqr, bufSiz, buf, 0x100000, len, msg );

_ERR:
	MM_setErrMsg(sqr,"[SC-55] displayed letter error!");
	return (-1);
}

/*************************************************************************
*	SC-55 tfBXvCɃhbg\
*-------------------------------------------------------------------------
*	$exSC55_dotSet( l0, l1, l2, .. l15);
*************************************************************************/

int		exSC55_dotSet( char *sqr, size_t bufSiz, char *buf, int argc, char **argv )
{
	int				i, level;
	char			*s, dat[128];
	unsigned char	dot[256];

	if ( argc < 16 )
		goto _ERR;

	for ( level = 0; level < 16; ++level )
	{
		s = argv[level];
		while ( isspace((int)(*s)) )
			++s;
		if ( strlen(s) < 16 )
			goto _ERR;

		for ( i = 0; i < 16; ++i )
		{
			dot[(level*16)+i] = _isSC55dot((int)(*s));
			++s;
		}
	}

	for ( i = 0; i < 16; ++i )
	{
		dat[i   ] = (dot[i*16+ 0]<<4) + (dot[i*16+ 1]<<3) + (dot[i*16+ 2]<<2) + (dot[i*16+ 3]<<1) + (dot[i*16+ 4]);
		dat[i+16] = (dot[i*16+ 5]<<4) + (dot[i*16+ 6]<<3) + (dot[i*16+ 7]<<2) + (dot[i*16+ 8]<<1) + (dot[i*16+ 9]);
		dat[i+32] = (dot[i*16+10]<<4) + (dot[i*16+11]<<3) + (dot[i*16+12]<<2) + (dot[i*16+13]<<1) + (dot[i*16+14]);
		dat[i+48] = (dot[i*16+15]<<4);
	}
	return sc55_genMML( sqr, bufSiz, buf, 0x100100, 64, dat );

_ERR:
	MM_setErrMsg(sqr,"[SC-55] displayed dot data error!");
	return (-1);
}

/*************************************************************************
*	w̑傫̃hbgobt@pӂ
*-------------------------------------------------------------------------
*	$SC55_initDotBuffer(x,y)
*************************************************************************/

int		SC55_initDotBuffer( char *sqr, size_t bufSiz, char *buf, int argc, char **argv )
{
	if ( argc < 2 )
		goto _ERR;
	Sc55dotBufXs = atoi(argv[0]);
	Sc55dotBufYs = atoi(argv[1]);
	if ( Sc55dotBufXs < 16 || Sc55dotBufYs < 16 )
		goto _ERR;
	if ( (Sc55dotBuffer = calloc(Sc55dotBufXs * Sc55dotBufYs,1)) == NULL )
		goto _ERR;
	buf[0] = '\0';
	return (0);

_ERR:
	MM_setErrMsg(sqr,"[SC55_initDotBuffer()] parameter error!");
	return (-1);
}

/*************************************************************************
*	hbgobt@̎wʒuɃhbgf[^ݒ肷
*-------------------------------------------------------------------------
*	$SC55_setDotBuffer(line,"dat")
*************************************************************************/

int		SC55_setDotBuffer( char *sqr, size_t bufSiz, char *buf, int argc, char **argv )
{
	char	*s;

	if ( Sc55dotBuffer == NULL || Sc55dotBufXs < 16 || Sc55dotBufYs < 16 )
	{
		MM_setErrMsg(sqr,"SC-55 dot buffer not initiarize!");
		return (-1);
	}

	if ( argc < 2 )
		goto _ERR;
	Sc55dotBufY = atoi(argv[0]);
	s = argv[1];
	while ( isspace(*s) )
		++s;
	if ( s )
	{
		for ( Sc55dotBufX = 0; Sc55dotBufX < Sc55dotBufXs; ++Sc55dotBufX )
		{
			Sc55dotBuffer[Sc55dotBufY * Sc55dotBufXs + Sc55dotBufX] = _isSC55dot(*s);
			++s;
			if ( *s == '\0' )
				break;
		}
	}
	return (0);

_ERR:
	MM_setErrMsg(sqr,"[SC55_setDotBuffer()] parameter error!");
	return (-1);
}

/*************************************************************************
*	hbgobt@̎wʒu16~16hbg\
*-------------------------------------------------------------------------
*	$exSC55_dotBuffer(x,y)
*************************************************************************/

int		exSC55_dotBuffer( char *sqr, size_t bufSiz, char *buf, int argc, char **argv )
{
	char			dat[128];
	unsigned char	dot[256];

	if ( Sc55dotBuffer == NULL || Sc55dotBufXs < 16 || Sc55dotBufYs < 16 )
	{
		MM_setErrMsg(sqr,"SC-55 dot buffer not initiarize!");
		return (-1);
	}

	if ( argc < 2 )
		goto _ERR;
	Sc55dotBufX = atoi(argv[0]);
	Sc55dotBufY = atoi(argv[1]);
	if ( Sc55dotBufX < 0 || Sc55dotBufX + 15 > Sc55dotBufXs || Sc55dotBufY < 0 || Sc55dotBufY + 15 > Sc55dotBufYs )
		goto _ERR;
	for ( Sc55dotBufC = 0; Sc55dotBufC < 16; ++Sc55dotBufC, ++Sc55dotBufY )
	{
		dat[Sc55dotBufC   ] = (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+ 0]<<4)
		                    + (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+ 1]<<3)
		                    + (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+ 2]<<2)
		                    + (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+ 3]<<1)
		                    + (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+ 4]);
		dat[Sc55dotBufC+16] = (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+ 5]<<4)
		                    + (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+ 6]<<3)
		                    + (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+ 7]<<2)
		                    + (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+ 8]<<1)
		                    + (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+ 9]);
		dat[Sc55dotBufC+32] = (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+10]<<4)
		                    + (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+11]<<3)
		                    + (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+12]<<2)
		                    + (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+13]<<1)
		                    + (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+14]);
		dat[Sc55dotBufC+48] = (Sc55dotBuffer[(Sc55dotBufY * Sc55dotBufXs)+Sc55dotBufX+15]<<4);
	}
	return sc55_genMML( sqr, bufSiz, buf, 0x100100, 64, dat );

_ERR:
	MM_setErrMsg(sqr,"\x22exSC55_dotBuffer()\x22 parameter error!");
	return (-1);
}
